<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use DB;

class CatalogueController extends Controller
{
   public function examName(){
	   
	try{
		
	   $exams = DB::table('books_master_table')->where('categories_id','!=',0)->groupBy('categories_id')->get();
	   foreach ($exams as $exam) {
			$exam_id = $exam->categories_id;
			
			$exam_query = DB::table('exam_master_table')->where('id',$exam_id)->first();
			
		    $exam_name = $exam_query->exam_name;
			
			$response[] = array('exam_id'=>$exam_id,'exam_name'=>$exam_name);
	   }
	   
   }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
   }
   echo json_encode($response);
   }
   
   
   //books
   public function bookDataApi(Request $req){
	   
	   $exam_id = isset($req['ex_id'])?$req['ex_id']:'1';
	 
	try{
		
	   $books_query = DB::table('books_master_table')->where('categories_id',$exam_id)->get();
	   foreach ($books_query as $book_data) {
			$book_id = $book_data->id;
			$book_price = $book_data->book_price;
			$book_image_path = $book_data->book_image_path;
			
			$response[] = array('book_id'=>$book_id,'book_price'=>$book_price,'book_image_path'=>$book_image_path);
	   }
	   
   }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
   }
   echo json_encode($response);
   } 
   
   //add to cart
   public function addCartApi(Request $req){
	   
	  $bookid = isset($req['bookid'])?$req['bookid']:'';
	  $quantity = isset($req['quantity'])?$req['quantity']:'';
	  $email_id = 'kaim@ssccglpinnacle.com';
	  
	  date_default_timezone_set('asia/kolkata');
	  $ts = date('y-m-d h:i:s');
	 
	try{
		
	   $book_count = DB::table('add_to_cart')->where('book_id',$bookid)->where('email_id',$email_id)->where('status',0)->count();
	   
	   if($book_count == 0){
	   $book_data = DB::table('books_master_table')->where('id',$bookid)->first();
	   
			$book_id = $book_data->id;
			$book_price = $book_data->book_price;
			$book_image_path = $book_data->book_image_path;
			
			$total_price = $book_price*$quantity;
			
			$response = DB::table('add_to_cart')->insert(
				   ['email_id'=>'kaim@ssccglpinnacle.com','book_id'=>$book_id,'quantity'=>$quantity,'price'=>$book_price,'total_price'=>$total_price,'ts'=>$ts]
			);
			
			$response = array('Remarks' =>'Successfully Added','status'=>'1');
		
	   }else{
		   
		  $qty_row = DB::table('add_to_cart')->where('book_id',$bookid)->where('email_id',$email_id)->first();
		  
		  $book_data = DB::table('books_master_table')->where('id',$bookid)->first();
	   
		  $book_id = $book_data->id;
		  $book_price = $book_data->book_price;
	      $book_image_path = $book_data->book_image_path;
		  
		  $new_total_price = $quantity * $book_price; 
		  
		  $qty_row = DB::table('add_to_cart')->where('book_id',$bookid)->where('email_id',$email_id)->where('status',0)->update(['quantity' => $quantity,'total_price'=>$new_total_price]);
		  
		  $response = array('Remarks' =>'Successfully Updated','status'=>'2'); 
	   }	
	   
   }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
   }
       echo json_encode($response);
   }
   
   //cart count
   public function CartApi(Request $req){
	   
	  $email_id = 'kaim@ssccglpinnacle.com';//isset($req['bookid'])?$req['bookid']:'';
	
	try{
		
	   $book_count = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->count();
	   
	   if($book_count >= 1){
		   
		$book_qty = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->sum('quantity');
	  
		$response = array('available_item' =>$book_qty,'status'=>'1');
		
	   }else{
		  $response[] = array('Remarks' =>'No item available','status'=>'0'); 
	   }	
	   
   }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
   }
   echo json_encode($response);
   } 
   
   //added cart
   public function AddedCartApi(Request $req){
	   
	  $book_id = isset($req['book_id'])?$req['book_id']:'';
	  $email_id = 'kaim@ssccglpinnacle.com';
	
	try{
		
	    $book_data = DB::table('books_master_table')->where('id',$book_id)->first();
	   
		$book_price = $book_data->book_price;
		$book_image_path = $book_data->book_image_path;
	    
		$cart_count = DB::table('add_to_cart')->where('email_id',$email_id)->count();
		
		
	   
	    if($cart_count >= 1){
			
		  $quantity_count = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->sum('quantity');
		
		  $total_price = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->sum('total_price');
	  
		  $response = array('book_image_path' =>$book_image_path,'cart_count'=>$quantity_count,'total_price'=>$total_price,'status'=>'1');
		
	    }else{
		  $response[] = array('Remarks' =>'No item available','status'=>'0'); 
	    }
	   
		
		
   }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
   }
   echo json_encode($response);
   }
   
    //cart list
	
   public function listcartApi(Request $req){
	 
	  $email_id = 'kaim@ssccglpinnacle.com';
	
	try{
		
		$cart_count = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->count();
		
		if($cart_count >= 1){
			
		$cart_row = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->get();

		foreach($cart_row as $row){
			
			$book_id = $row->book_id;
			$quantity = $row->quantity;
			$price = $row->price;
			
			$book_data = DB::table('books_master_table')->where('id',$book_id)->first();
	   
		    $book_title = $book_data->book_title;
		    $book_image_path = $book_data->book_image_path;
			
			//$cart_price = $quantity*$price;
			
			$quantity_count = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->sum('quantity');
		
		    $total_price = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->sum('total_price');
			
			$response[] = array('bookid'=>$book_id,'book_title'=>$book_title,'book_image_path' =>$book_image_path,'quantity'=>$quantity,'total_count'=>$quantity_count,'price'=>$price,'total_price'=>$total_price,'status'=>'1');	
		}
		
		}else{
			
		   $response[] = array('Remarks' =>'No item available','status'=>'0'); 
		   
	    }
	
   }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
   }
      echo json_encode($response);
   }
   
   //delete cart
    public function DeleteCartApi(Request $req){
	   
	  $book_id = isset($req['bookid'])?$req['bookid']:'';
	  $email_id = 'kaim@ssccglpinnacle.com';
	
	try{
	
		$cart_count = DB::table('add_to_cart')->where('email_id',$email_id)->where('book_id',$book_id)->delete();
		
		$response = array('Remarks' =>'deleted','status'=>'1'); 
		
    }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
    }
       echo json_encode($response);
    }
	
	//save for later
	
	public function SaveForLaterCartApi(Request $req){
	   
	  $book_id = isset($req['bookid'])?$req['bookid']:'';
	  $email_id = 'kaim@ssccglpinnacle.com';
	
	try{
	
		$cart_count = DB::table('add_to_cart')->where('email_id',$email_id)->where('book_id',$book_id)->where('status',0)->update(['status'=>3]);
		
		$response = array('Remarks' =>'Updated for later','status'=>'1'); 
		
    }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
    }
       echo json_encode($response);
    }
   
   //listing for save later 
   
    public function savelaterlistApi(Request $req){
	 
	  $email_id = 'kaim@ssccglpinnacle.com';
	
	try{
		
		$cart_count = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',3)->count();
		
		if($cart_count >= 1){
			
		$cart_row = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',3)->get();

		foreach($cart_row as $row){
			
			$book_id = $row->book_id;
			
			$book_data = DB::table('books_master_table')->where('id',$book_id)->first();
	   
		    $book_title = $book_data->book_title;
		    $book_image_path = $book_data->book_image_path;
			
			$response[] = array('bookid'=>$book_id,'book_title'=>$book_title,'book_image_path' =>$book_image_path,'saved_item'=>$cart_count,'status'=>'1');	
		}
		
		}else{
			
		   $response[] = array('Remarks' =>'No item available','status'=>'0'); 
		   
	    }
	
    }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
    }
      echo json_encode($response);
    }
	
	//from save to add
	public function savetoaddApi(Request $req){
	   
	  $book_id = isset($req['bookid'])?$req['bookid']:'';
	  $email_id = 'kaim@ssccglpinnacle.com';
	
	try{
		
		$cart_count = DB::table('add_to_cart')->where('email_id',$email_id)->where('book_id',$book_id)->where('status',3)->count();
	    if($cart_count >= 0){
		$cart_update = DB::table('add_to_cart')->where('email_id',$email_id)->where('book_id',$book_id)->where('status',3)->update(['status'=>0]);
		
		    $response = array('Remarks' =>'Updated for cart','status'=>'1');
		
		}else{
			
			$response = array('Remarks' =>'0 item','status'=>'0');
			
		}		
		
    }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
    }
       echo json_encode($response);
    }
	
	//popular book
	public function popularBookApi(Request $req){
	   
	try{
		
	   $books_query = DB::table('books_master_table')->orderBy('id', 'desc')->take(4)->get();
	   foreach ($books_query as $book_data) {
			$book_id = $book_data->id;
			$book_price = $book_data->book_price;
			$book_image_path = $book_data->book_image_path;
			$book_title = $book_data->book_title;
			
			$response[] = array('book_id'=>$book_id,'book_title'=>$book_title,'book_price'=>$book_price,'book_image_path'=>$book_image_path);
	   }
	   
   }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
   }
   echo json_encode($response);
   } 
   
   //paticular book details
   
   public function BookDetailedApi(Request $req){
	 
	  $book_id = isset($req['book_id'])?$req['book_id']:'';
	
	try{

		$book_data = DB::table('books_master_table')->where('id',$book_id)->first();
   
		$book_title = $book_data->book_title;
		$book_image_path = $book_data->book_image_path;
		$book_price = $book_data->book_price;
		$book_max_price = $book_data->book_max_price;
		
		$small_book_count = DB::table('book_small_images')->where('book_id',$book_id)->count();
		
		if($small_book_count > 0){
		
		$small_book_data = DB::table('book_small_images')->where('book_id',$book_id)->get();
		
		foreach($small_book_data as $data){
			
			$s_img = $data->book_img;
			
			$ar[] = array('s_img'=>$s_img);
			
		}
		
		$small_img_count = count($ar);
		
		}else{
			$ar[] = array('s_img'=>0);
			$small_img_count = 0;
		}
		
		
		$saved_price = $book_max_price - $book_price;
		
		$saved_per = round((($saved_price * 100)/$book_max_price),2);
		
		$response[] = array('book_id'=>$book_id,'book_title'=>$book_title,'book_image_path' =>$book_image_path,'book_price'=>$book_price,'book_max_price'=>$book_max_price,'status'=>'1','small_img'=>$ar,'small_img_count'=>$small_img_count,'saved_price'=>$saved_price,'saved_per'=>$saved_per);	

    }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
    }
       echo json_encode($response);
    }
	
	//add to wishlist
	public function addWishListApi(Request $req){
	   
	  $bookid = isset($req['bookid'])?$req['bookid']:'';
	  $email_id = 'kaim@ssccglpinnacle.com';
	  
	  date_default_timezone_set('asia/kolkata');
	  $ts = date('y-m-d h:i:s');
	 
	try{
		
	   $book_count = DB::table('add_to_cart')->where('book_id',$bookid)->where('email_id',$email_id)->where('status',1)->count();
	   
	   if($book_count == 0){
	        $book_data = DB::table('books_master_table')->where('id',$bookid)->first();
	   
			$book_id = $book_data->id;
			$book_price = $book_data->book_price;
			$book_image_path = $book_data->book_image_path;
			
			$response = DB::table('add_to_cart')->insert(
				   ['email_id'=>'kaim@ssccglpinnacle.com','book_id'=>$book_id,'quantity'=>'1','price'=>$book_price,'total_price'=>$book_price,'status'=>1,'ts'=>$ts]
			);
			
			$response = array('Remarks' =>'Successfully Added','status'=>'1');
		
	    }else{
		  
		  $response = array('Remarks' =>'already exist','status'=>'0'); 
		  
	    }	
	   
    }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
    }
       echo json_encode($response);
    }
	
	//added wishlisting cart
	public function addedWishListApi(Request $req){
	   
	  $bookid = isset($req['book_id'])?$req['book_id']:'';
	  $email_id = 'kaim@ssccglpinnacle.com';
	  
	try{
		
	   $book_count = DB::table('add_to_cart')->where('book_id',$bookid)->where('email_id',$email_id)->where('status',1)->count();
	   
	   if($book_count >= 1){
	        $book_data = DB::table('books_master_table')->where('id',$bookid)->first();

			$book_title = $book_data->book_title;
			$book_image_path = $book_data->book_image_path;
			
			$response[] = array('book_id'=>$bookid,'book_title' =>$book_title,'book_image_path'=>$book_image_path,'status'=>'1');
		
	    }else{
		  
		  $response = array('Remarks' =>'No wishlist','status'=>'0'); 

	    }	
	   
    }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
    }
       echo json_encode($response);
    }
	
	// wishlisting cart
	public function WishListingApi(Request $req){
	
	  $email_id = isset($req['userid'])?$req['userid']:'';
	
	try{
		
	   $book_count = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',1)->count();
	   
	   if($book_count >= 1){
		   
		    $book_row = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',1)->get();
			
			foreach($book_row as $row){
				
			$bookid = $row->book_id;
		   
	        $book_data = DB::table('books_master_table')->where('id',$bookid)->first();

			$book_title = $book_data->book_title;
			$book_image_path = $book_data->book_image_path;
			
			$response[] = array('book_id'=>$bookid,'book_title' =>$book_title,'book_image_path'=>$book_image_path,'status'=>'1');
			}
		
	    }else{
		  
		  $response = array('Remarks' =>'No wishlist','status'=>'0'); 

	    }	
	   
    }catch(Exception $e){
	   return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
    }
       echo json_encode($response);
    }
 
}
