<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\productController;
use App\Http\Controllers\LoginController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\RegisterController;
use App\Http\Controllers\otpController;
use App\Http\Controllers\CatalogueController;

/* 
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

// Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    // return $request->user();
// });
Route::group(['middleware' => 'auth:sanctum'], function(){
    //All secure URL's
    Route::get('index',[productController::class,'ap']);
	Route::delete('del/{id}',[productController::class,'delt']);
	Route::put('update/{id}',[productController::class,'update']);
	Route::post('login',[LoginController::class,'loginApi']);
});

  
Route::post('loginbyauth',[UserController::class,'index']);
Route::post('register',[RegisterController::class,'RegisterApi']);
Route::post('otp',[otpController::class,'otpApi']);
Route::get('exams',[CatalogueController::class,'examName']);
Route::post('addcart',[CatalogueController::class,'addCartApi']);
Route::post('booksdetils',[CatalogueController::class,'bookDataApi']);
Route::get('cart',[CatalogueController::class,'CartApi']);
Route::post('addedcart',[CatalogueController::class,'AddedCartApi']);
Route::get('listcart',[CatalogueController::class,'listcartApi']);
Route::post('deletecart',[CatalogueController::class,'DeleteCartApi']);
Route::post('saveforlater',[CatalogueController::class,'SaveForLaterCartApi']);
Route::get('saveforlaterlist',[CatalogueController::class,'savelaterlistApi']);
Route::post('fromsavetoadd',[CatalogueController::class,'savetoaddApi']);
Route::get('popularBook',[CatalogueController::class,'popularBookApi']);
Route::post('bookdetailed',[CatalogueController::class,'BookDetailedApi']);
Route::post('addwishcart',[CatalogueController::class,'addWishListApi']);
Route::post('addedwishlist',[CatalogueController::class,'addedWishListApi']);
Route::post('wishlisting',[CatalogueController::class,'WishListingApi']);

